<?php

  require_once( 'config.php' );
  require_once( 'standards.php' );
  require_once( 'read_local_config.php' );

  if ( !is_dir(dirname(__FILE__) . '/js/tinymce') ) {
      echo "<p>You haven't installed the tinyMCE Keystone plugin. On Debian ";
      echo "simply execute this as super-user:</p>";
      echo "  apt-get install tklite-tinymce";
      exit;
  }

  if ( isset( $_REQUEST['cwd'] ) )
      $cwd = $_REQUEST['cwd'];
  else
      die( __FILE__ . ': CWD must be provided' );

  find_portal_root();

  if ( !is_array($settings = get_tkl_config('tiny_mce')) ) {
      $settings = array();
  }

  $js_hash = '';

  foreach ( $settings as $key => $value ) {
      $js_hash .= $key . ' : "' . $value . "\",\n";
  }

?>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Editor</title>
<!-- TinyMCE -->
<script language="javascript" type="text/javascript" src="admin/xform.js"></script>
<script language="javascript" type="text/javascript" src="js/tinymce/tiny_mce.js"></script>
<script language="javascript" type="text/javascript">
	tinyMCE.init({
		theme : "advanced",
		plugins : "style,layer,table,save,advhr,advimage,advlink,emotions,iespell,insertdatetime,preview,flash,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable",
		theme_advanced_buttons1_add_before : "save,newdocument,separator",
		theme_advanced_buttons1_add : "fontselect,fontsizeselect",
		theme_advanced_buttons2_add : "separator,insertdate,inserttime,preview,separator,forecolor,backcolor",
		theme_advanced_buttons2_add_before: "cut,copy,paste,pastetext,pasteword,separator,search,replace,separator",
		theme_advanced_buttons3_add_before : "tablecontrols,separator",
		theme_advanced_buttons3_add : "emotions,iespell,flash,advhr,separator,print,separator,ltr,rtl,separator,fullscreen",
		theme_advanced_buttons4 : "insertlayer,moveforward,movebackward,absolute,|,styleprops",
		theme_advanced_toolbar_location : "top",
		theme_advanced_toolbar_align : "left",
		theme_advanced_path_location : "bottom",
                plugin_insertdate_dateFormat : "%Y-%m-%d",
                plugin_insertdate_timeFormat : "%H:%M:%S",
		extended_valid_elements : "hr[class|width|size|noshade],font[face|size|color|style],span[class|align|style]",
		theme_advanced_resize_horizontal : false,
		theme_advanced_resizing : true,

                <?php echo $js_hash; ?>

		mode : "textareas",
                entity_encoding : "numeric",
                save_callback : "update_cell",
                setupcontent_callback : "update_editor",
                keystone_src_cell_id : "<?php echo $_REQUEST['cell_id'] ?>"
	});

</script>
<!-- /TinyMCE -->
</head>
<body>
  <form method="post" name="user_input">
    <textarea id="editor_cell" name="editor_cell" rows="15" cols="80" style="width: 100%">
    </textarea>
</form>

</body>
</html>
